diff -ruN ../nakedmudv2.7/src/items/portal.c src/items/portal.c
--- ../nakedmudv2.7/src/items/portal.c	Sun Jul 31 17:13:51 2005
+++ src/items/portal.c	Fri Oct  7 14:15:55 2005
@@ -7,11 +7,11 @@
 // destinations when someone wants to interact with a portal.
 //
 //*****************************************************************************
-
 #include "../mud.h"
 #include "../utils.h"
 #include "../storage.h"
 #include "../character.h"
+#include "../object.h"
 #include "../socket.h"
 #include "../room.h"
 #include "../world.h"
@@ -24,25 +24,37 @@
 #include "iedit.h"
 
 
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pyobj.h"
+#include "../scripts/pyroom.h"
+
+
+
 //*****************************************************************************
 // item data for portals
 //*****************************************************************************
 typedef struct portal_data {
-  int dest;
+  char *dest;
 } PORTAL_DATA;
 
 PORTAL_DATA *newPortalData() {
   PORTAL_DATA *data = malloc(sizeof(PORTAL_DATA));
-  data->dest = NOWHERE;
+  data->dest = strdup("");
   return data;
 }
 
 void deletePortalData(PORTAL_DATA *data) {
+  if(data->dest) free(data->dest);
   free(data);
 }
 
 void portalDataCopyTo(PORTAL_DATA *from, PORTAL_DATA *to) {
-  to->dest = from->dest;
+  if(to->dest) free(to->dest);
+  to->dest = strdupsafe(from->dest);
 }
 
 PORTAL_DATA *portalDataCopy(PORTAL_DATA *data) {
@@ -53,13 +65,13 @@
 
 STORAGE_SET *portalDataStore(PORTAL_DATA *data) {
   STORAGE_SET *set = new_storage_set();
-  store_int(set, "dest", data->dest);
+  store_string(set, "dest", data->dest);
   return set;
 }
 
 PORTAL_DATA *portalDataRead(STORAGE_SET *set) {
   PORTAL_DATA *data = newPortalData();
-  data->dest = read_int(set, "dest");
+  data->dest = strdup(read_string(set, "dest"));
   return data;
 }
 
@@ -68,64 +80,56 @@
 //*****************************************************************************
 // functions for interacting with portals
 //*****************************************************************************
-int portalGetDest(OBJ_DATA *obj) {
+const char *portalGetDest(OBJ_DATA *obj) {
   PORTAL_DATA *data = objGetTypeData(obj, "portal");
   return data->dest;
 }
 
-void portalSetDest(OBJ_DATA *obj, int dest) {
+void portalSetDest(OBJ_DATA *obj, const char *dest) {
   PORTAL_DATA *data = objGetTypeData(obj, "portal");
-  data->dest = dest;
+  if(data->dest) free(data->dest);
+  data->dest = strdupsafe(dest);
 }
 
 
 //
 // cmd_enter is used to go through portals
-//   usage: enter [object]
+//   usage: enter <object>
 //
 //   examples:
 //     enter portal         enter the thing called "portal" in your room
 COMMAND(cmd_enter) {
-  if(!arg || !*arg)
-    send_to_char(ch, "What did you want to enter?\r\n");
-  else {
-    int found_type = FOUND_NONE;
-    void *found = generic_find(ch, arg,
-			       FIND_TYPE_OBJ | FIND_TYPE_EXIT,
-			       FIND_SCOPE_IMMEDIATE,
-			       FALSE, &found_type);
+  void    *found = NULL;
+  int found_type = PARSE_NONE;
 
+  if(!parse_args(ch, TRUE, cmd, arg, "{ obj.room exit } ", &found, &found_type))
+    return;
 
-    // we're trying to enter an exit
-    if(found && found_type == FOUND_EXIT) {
-      ROOM_DATA *to = try_exit(ch, found, DIR_NONE);
-      if(to != NULL) look_at_room(ch, to);
-    }
+  // we're trying to enter an exit
+  if(found_type == PARSE_EXIT) {
+    if(try_move_mssg(ch, roomGetExitDir(charGetRoom(ch), found)))
+      look_at_room(ch, charGetRoom(ch));
+  }
 
-    // we're trying to enter a portal
-    else if(found && found_type == FOUND_OBJ) {
-      if(!objIsType(found, "portal"))
-	send_to_char(ch, "You cannot seem to find an enterance.\r\n");
+  // we're trying to enter a portal
+  else {
+    if(!objIsType(found, "portal"))
+      send_to_char(ch, "You cannot seem to find an enterance.\r\n");
+    else {
+      ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(found));
+      if(dest == NULL)
+	send_to_char(ch, "There is nothing on the other side...\r\n");
       else {
-	ROOM_DATA *dest = worldGetRoom(gameworld, portalGetDest(found));
-	if(!dest)
-	  send_to_char(ch, 
-		       "You go to enter the portal, "
-		       "but dark forces prevent you!\r\n");
-	else {
-	  send_to_char(ch, "You step through %s.\r\n", see_obj_as(ch, found));
-	  message(ch, NULL, found, NULL, TRUE, TO_ROOM,
-		  "$n steps through $o.");
-	  char_from_room(ch);
-	  char_to_room(ch, dest);
-	  look_at_room(ch, dest);
-	  message(ch, NULL, found, NULL, TRUE, TO_ROOM,
-		  "$n arrives after travelling through $o.");
-	}
+	send_to_char(ch, "You step through %s.\r\n", see_obj_as(ch, found));
+	message(ch, NULL, found, NULL, TRUE, TO_ROOM,
+		"$n steps through $o.");
+	char_from_room(ch);
+	char_to_room(ch, dest);
+	look_at_room(ch, dest);
+	message(ch, NULL, found, NULL, TRUE, TO_ROOM,
+		"$n arrives after travelling through $o.");
       }
     }
-    else
-      send_to_char(ch, "What were you trying to enter?\r\n");
   }
 }
 
@@ -138,16 +142,14 @@
 
 // the resedit olc needs these declared
 void iedit_portal_menu   (SOCKET_DATA *sock, PORTAL_DATA *data) {
-  ROOM_DATA *dest = worldGetRoom(gameworld, data->dest);
-  send_to_socket(sock, "{g1) Destination: {c%d (%s)\r\n", data->dest,
-		 (dest ? roomGetName(dest) : "nowhere"));
+  send_to_socket(sock, "{g1) Destination: {c%s\r\n", data->dest);
 }
 
 int  iedit_portal_chooser(SOCKET_DATA *sock, PORTAL_DATA *data, 
 			  const char *option) {
   switch(toupper(*option)) {
   case '1': 
-    text_to_buffer(sock, "Enter new destination (-1 for none): ");
+    text_to_buffer(sock, "Enter new destination (return for none): ");
     return IEDIT_PORTAL_DEST;
   default:
     return MENU_CHOICE_INVALID;
@@ -158,15 +160,8 @@
 			  const char *arg) {
   switch(choice) {
   case IEDIT_PORTAL_DEST: {
-    int dest = atoi(arg);
-    // ugh... ugly logic. Clean this up one day?
-    //   Make sure what we're getting is a positive number or make sure it is
-    //   the NOWHERE number (-1). Also make sure that, if it's not NOWHERE, it
-    //   corresponds to a vnum of a room already created.
-    if((dest != NOWHERE && !worldGetRoom(gameworld, dest)) ||
-       (dest != NOWHERE && !isdigit(*arg)))
-      return FALSE;
-    data->dest = dest;
+    if(data->dest) free(data->dest);
+    data->dest   = strdupsafe(arg);
     return TRUE;
   }
   default:
@@ -174,6 +169,63 @@
   }
 }
 
+void portal_from_proto(PORTAL_DATA *data, BUFFER *buf) {
+  if(*bufferString(buf)) {
+    char dest[SMALL_BUFFER];
+    sscanf(bufferString(buf), "me.portal_dest = \"%s", dest);
+    dest[next_letter_in(dest, '\"')] = '\0'; // kill closing "
+    if(data->dest) free(data->dest);
+    data->dest = strdupsafe(dest);
+  }
+}
+
+void portal_to_proto(PORTAL_DATA *data, BUFFER *buf) {
+  if(*data->dest)
+    bprintf(buf, "me.portal_dest = \"%s\"\n", data->dest);
+}
+
+
+
+//*****************************************************************************
+// pyobj getters and setters
+//*****************************************************************************
+PyObject *PyObj_getportaldest(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "portal"))
+    return Py_BuildValue("s", portalGetDest(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get destination for portals.");
+    return NULL;
+  }
+}
+
+int PyObj_setportaldest(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to set destination for "
+		 "nonexistent portal, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "portal")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set destination for non-portal, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(PyString_Check(value))
+    portalSetDest(obj, PyString_AsString(value));
+  else if(PyRoom_Check(value))
+    portalSetDest(obj, roomGetClass(PyRoom_AsRoom(value)));
+  else {
+    PyErr_Format(PyExc_TypeError, "portal dest must be a room or string.");
+    return -1;
+  }
+
+  return 0;
+}
+
 
 
 //*****************************************************************************
@@ -190,8 +242,12 @@
 
   // set up the portal OLC too
   item_add_olc("portal", iedit_portal_menu, iedit_portal_chooser, 
-	       iedit_portal_parser);
+	       iedit_portal_parser, portal_from_proto, portal_to_proto);
+
+  // make it so we can set portal destinations in scripts
+  PyObj_addGetSetter("portal_dest", PyObj_getportaldest, PyObj_setportaldest,
+		     "the database key of the room we're going to.");
 
-  add_cmd("enter", NULL, cmd_enter, 0, POS_STANDING, POS_FLYING,
+  add_cmd("enter", NULL, cmd_enter, POS_STANDING, POS_FLYING,
 	  "player", TRUE, TRUE);
 }
diff -ruN ../nakedmudv2.7/src/items/portal.h src/items/portal.h
--- ../nakedmudv2.7/src/items/portal.h	Sun Jul 31 17:13:51 2005
+++ src/items/portal.h	Fri Oct  7 14:15:55 2005
@@ -11,11 +11,11 @@
 //*****************************************************************************
 
 //
-// return the vnum of the room that the portal leads to
-int portalGetDest(OBJ_DATA *obj);
+// return the key of the room that the portal leads to
+const char *portalGetDest(OBJ_DATA *obj);
 
 //
 // set the destination of the portal
-void portalSetDest(OBJ_DATA *obj, int dest);
+void portalSetDest(OBJ_DATA *obj, const char *dest);
 
 #endif // PORTAL_H
diff -ruN ../nakedmudv2.7/src/items/worn.c src/items/worn.c
--- ../nakedmudv2.7/src/items/worn.c	Sun Jul 31 17:13:51 2005
+++ src/items/worn.c	Fri Oct  7 14:15:55 2005
@@ -26,6 +26,7 @@
 #include "../socket.h"
 #include "../room.h"
 #include "../world.h"
+#include "../object.h"
 #include "../inform.h"
 #include "../handler.h"
 
@@ -37,6 +38,14 @@
 
 
 //*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "../scripts/scripts.h"
+#include "../scripts/pyobj.h"
+
+
+
+//*****************************************************************************
 // local functions, variables, datastructures, and defines
 //*****************************************************************************
 HASHTABLE *worn_table = NULL;
@@ -48,8 +57,8 @@
 
 WORN_ENTRY *newWornEntry(const char *type, const char *positions) {
   WORN_ENTRY *entry = malloc(sizeof(WORN_ENTRY));
-  entry->type      = strdup(type ? type : "");
-  entry->positions = strdup(positions ? positions : "");
+  entry->type      = strdupsafe(type);
+  entry->positions = strdupsafe(positions);
   return entry;
 }
 
@@ -86,7 +95,7 @@
 
 void wornDataCopyTo(WORN_DATA *from, WORN_DATA *to) {
   if(to->type) free(to->type);
-  to->type = strdup(from->type ? from->type : "");
+  to->type = strdupsafe(from->type);
 }
 
 WORN_DATA *wornDataCopy(WORN_DATA *data) {
@@ -125,7 +134,7 @@
 void wornSetType(OBJ_DATA *obj, const char *type) {
   WORN_DATA *data = objGetTypeData(obj, "worn");
   if(data->type) free(data->type);
-  data->type = strdup(type ? type : "");
+  data->type = strdupsafe(type);
 }
 
 
@@ -152,7 +161,7 @@
   LIST_ITERATOR *type_i = newListIterator(types);
   int col = 0;
 
-  text_to_buffer(sock, "{wEditable item types:\r\n");
+  text_to_buffer(sock, "{wEditable item types:{g\r\n");
   ITERATE_LIST(key, type_i) {
     send_to_socket(sock, "  %-14s%s",
 		   key, ((col != 0 && col % 3 == 0) ? "\r\n": "   "));
@@ -198,6 +207,65 @@
   }
 }
 
+void worn_from_proto(WORN_DATA *worn, BUFFER *buf) {
+  char worn_type[SMALL_BUFFER];
+  sscanf(bufferString(buf), "me.worn_type = \"%s", worn_type);
+  worn_type[next_letter_in(worn_type, '\"')] = '\0'; // kill closing "
+  if(hashIn(worn_table, worn_type)) {
+    if(worn->type) free(worn->type);
+    worn->type = strdup(worn_type);
+  }
+}
+
+void worn_to_proto(WORN_DATA *worn, BUFFER *buf) {
+  bprintf(buf, "me.worn_type = \"%s\"\n", worn->type);
+}
+
+
+
+//*****************************************************************************
+// python extentions
+//*****************************************************************************
+PyObject *PyObj_getworntype(PyObject *self, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL)
+    return NULL;
+  else if(objIsType(obj, "worn"))
+    return Py_BuildValue("s", wornGetType(obj));
+  else {
+    PyErr_Format(PyExc_TypeError, "Can only get worntype for wearable items.");
+    return NULL;
+  }
+}
+
+int PyObj_setworntype(PyObject *self, PyObject *value, void *closure) {
+  OBJ_DATA *obj = PyObj_AsObj(self);
+  if(obj == NULL) {
+    PyErr_Format(PyExc_StandardError, "Tried to set worntype for nonexistent "
+		 "clothing, %d", PyObj_AsUid(self));
+    return -1;
+  }
+  else if(!objIsType(obj, "worn")) {
+    PyErr_Format(PyExc_TypeError, "Tried to set worntype for non-clothing, %s",
+		 objGetClass(obj));
+    return -1;
+  }
+
+  if(!PyString_Check(value)) {
+    PyErr_Format(PyExc_TypeError, "Clothing worntype must be a string.");
+    return -1;
+  }
+  
+  if(!hashIn(worn_table, PyString_AsString(value))) {
+    PyErr_Format(PyExc_TypeError, "Invalid worn type, %s.", 
+		 PyString_AsString(value));
+    return -1;
+  }
+
+  wornSetType(obj, PyString_AsString(value));
+  return 0;
+}
+
 
 
 //*****************************************************************************
@@ -223,8 +291,13 @@
 		wornDataStore, wornDataRead);
 
   // set up the worn OLC too
-  item_add_olc("worn", iedit_worn_menu, iedit_worn_chooser, iedit_worn_parser);
+  item_add_olc("worn", iedit_worn_menu, iedit_worn_chooser, iedit_worn_parser,
+	       worn_from_proto, worn_to_proto);
 
+  // add our new python get/setters
+  PyObj_addGetSetter("worn_type", PyObj_getworntype, PyObj_setworntype,
+		     "The type of clothing this wearable item is.");
+  
   // add in our basic worn types
   worn_add_type("shirt",                        "torso");
   worn_add_type("gloves",       "left hand, right hand");
diff -ruN ../nakedmudv2.7/src/list.c src/list.c
--- ../nakedmudv2.7/src/list.c	Sun Jul 31 17:13:53 2005
+++ src/list.c	Fri Oct  7 14:15:55 2005
@@ -284,11 +284,11 @@
 }
 
 void *listHead(LIST *L) {
-  return L->head;
+  return listGet(L, 0);
 }
 
 void *listTail(LIST *L) {
-  return L->tail;
+  return listGet(L, L->size-1);
 }
 
 int isListEmpty(LIST *L) {
diff -ruN ../nakedmudv2.7/src/log.c src/log.c
--- ../nakedmudv2.7/src/log.c	Sun Jul 31 17:13:53 2005
+++ src/log.c	Fri Oct  7 14:15:55 2005
@@ -98,7 +98,7 @@
     storage_close(set);
   }
 
-  add_cmd("log", NULL, cmd_log, 0, POS_UNCONCIOUS, POS_FLYING,
+  add_cmd("log", NULL, cmd_log, POS_UNCONCIOUS, POS_FLYING,
 	  "admin", FALSE, FALSE);
 }
 
@@ -108,7 +108,7 @@
   char *keys = hashRemove(logkeys, file);
   if(keys) free(keys);
 
-  keys = strdup(keywords ? keywords : "");
+  keys = strdupsafe(keywords);
   trim(keys);
 
   // put the new keywords in
diff -ruN ../nakedmudv2.7/src/map.c src/map.c
--- ../nakedmudv2.7/src/map.c	Sun Jul 31 17:13:53 2005
+++ src/map.c	Fri Oct  7 14:15:55 2005
@@ -152,12 +152,8 @@
 void  deleteMap(MAP *map) {
   int i;
   for(i = 0; i < map->num_buckets; i++) {
-    if(map->buckets[i]) {
-      MAP_ENTRY *entry = NULL;
-      while((entry = listPop(map->buckets[i])) !=NULL)
-	deleteMapEntry(entry);
-      deleteList(map->buckets[i]);
-    }
+    if(map->buckets[i])
+      deleteListWith(map->buckets[i], deleteMapEntry);
   }
   free(map->buckets);
   free(map);
diff -ruN ../nakedmudv2.7/src/movement.c src/movement.c
--- ../nakedmudv2.7/src/movement.c	Sun Jul 31 19:00:40 2005
+++ src/movement.c	Fri Oct  7 14:15:55 2005
@@ -7,160 +7,119 @@
 //*****************************************************************************
 
 #include "mud.h"
+#include "utils.h"
 #include "character.h"
 #include "world.h"
 #include "zone.h"
 #include "room.h"
 #include "exit.h"
-#include "movement.h"
 #include "handler.h"
 #include "inform.h"
-#include "utils.h"
 #include "object.h"
+#include "movement.h"
+#include "hooks.h"
 
 
 
 //*****************************************************************************
 // mandatory modules
 //*****************************************************************************
-#include "scripts/script.h"
 #include "items/items.h"
 #include "items/furniture.h"
 
 
 
-ROOM_DATA *try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir) {
-  ROOM_DATA *to   = NULL;
+//*****************************************************************************
+// implementation of movement.h
+//*****************************************************************************
+EXIT_DATA *try_move_mssg(CHAR_DATA *ch, const char *dir) {
+  ROOM_DATA *old_room = charGetRoom(ch);
+  EXIT_DATA     *exit = try_move(ch, dir);
+  
+  // did we successfully move?
+  if(exit != NULL) {
+    ROOM_DATA *new_room = charGetRoom(ch);
+    int          dirnum = dirGetNum(dir);
+    // are we using an abbreviated direction name?
+    if(dirnum == DIR_NONE && !roomGetExit(old_room, dir))
+      dirnum = dirGetAbbrevNum(dir);
 
-  if(exitIsClosed(exit))
-    send_to_char(ch, "You must open %s first.\r\n", exitGetName(exit));
-  else if(exitGetTo(exit) == NOWHERE || 
-	  (to = worldGetRoom(gameworld, exitGetTo(exit))) == NULL)
-    send_to_char(ch, "It doesn't look like %s leads anywhere!", 
-		 exitGetName(exit));
-  else {
+    // now, we have to temporarily go back to the old room so we can do
+    // leave messages. Then we come back to the new room and do enter messages
+    char_from_room(ch);
+    char_to_room(ch, old_room);
     if(*exitGetSpecLeave(exit))
       message(ch, NULL, NULL, NULL, TRUE, TO_ROOM, exitGetSpecLeave(exit));
-    else if(dir != DIR_NONE)
-      send_around_char(ch, TRUE, "%s leaves %s.\r\n",
-		       charGetName(ch), dirGetName(dir));
-    else
+    else if(dirnum == DIR_NONE)
       send_around_char(ch, TRUE, "%s leaves.\r\n", charGetName(ch));
-
+    else
+      send_around_char(ch, TRUE, "%s leaves %s.\r\n", charGetName(ch), 
+		       dirGetName(dirnum));
     char_from_room(ch);
-    char_to_room(ch, to);
-
+    char_to_room(ch, new_room);
+    
+    // do we have a special enter message? If so, use them
     if(*exitGetSpecEnter(exit))
       message(ch, NULL, NULL, NULL, FALSE, TO_ROOM, exitGetSpecEnter(exit));
-    else if(dir != DIR_NONE)
-      send_around_char(ch, TRUE, "%s arrives from the %s.\r\n",
-		       charGetName(ch), dirGetName(dirGetOpposite(dir)));
-    else
+    else if(dirnum == DIR_NONE)
       send_around_char(ch, TRUE, "%s has arrived.\r\n", charGetName(ch));
-
-    return to;
+    else
+      send_around_char(ch, TRUE, "%s arrives from the %s.\r\n",
+		       charGetName(ch), dirGetName(dirGetOpposite(dirnum)));
   }
-  return NULL;
+  return exit;
 }
 
-
-bool try_buildwalk(CHAR_DATA *ch, int dir) {
-  ZONE_DATA *zone = worldZoneBounding(gameworld, roomGetVnum(charGetRoom(ch)));
-  
-  if(!canEditZone(zone, ch))
-    send_to_char(ch, "You are not authorized to edit this zone.\r\n");
-  else if(roomGetExit(charGetRoom(ch), dir))
-    send_to_char(ch, "You try to buildwalk %s, but a room already exists in that direction!\r\n", dirGetName(dir));
-  else if(!zone) {
-    send_to_char(ch, "The room you are in is not attached to a zone!\r\n");
-    log_string("ERROR: %s tried to buildwalk %s, but room %d was not in a zone!", charGetName(ch), dirGetName(dir), roomGetVnum(charGetRoom(ch)));
+EXIT_DATA *try_move(CHAR_DATA *ch, const char *dir) {
+  EXIT_DATA *exit = roomGetExit(charGetRoom(ch), dir);
+  ROOM_DATA   *to = NULL;
+
+  // are we using an abbreviated direction name?
+  if(exit == NULL && dirGetAbbrevNum(dir) != DIR_NONE) {
+    dir  = dirGetName(dirGetAbbrevNum(dir));
+    exit = roomGetExit(charGetRoom(ch), dir);
   }
+
+  // did we find an exit?
+  if(exit == NULL || !can_see_exit(ch, exit))
+    send_to_char(ch, "{gAlas, there is no exit in that direction.\r\n");
+  else if(exitIsClosed(exit))
+    send_to_char(ch, "You will have to open %s first.\r\n",
+		 (*exitGetName(exit) ? exitGetName(exit) : "it"));
+  else if((to = worldGetRoom(gameworld, exitGetTo(exit))) == NULL)
+    send_to_char(ch, "It doesn't look like %s leads anywhere!", 
+		 (*exitGetName(exit) ? exitGetName(exit) : "it"));
   else {
-    int vnum = getFreeRoomVnum(zone);
-    if(vnum == NOWHERE)
-      send_to_char(ch, 
-		   "Zone #%d has no free rooms left. "
-		   "Buildwalk could not be performed.\r\n", zoneGetVnum(zone));
-    else {
-      char desc[MAX_BUFFER];
-      ROOM_DATA *new_room = newRoom();
-      roomSetVnum(new_room, vnum);
-      roomSetTerrain(new_room, roomGetTerrain(charGetRoom(ch)));
-
-      roomSetName(new_room, "A New Buildwalk Room");
-      sprintf(desc, "This room was created by %s.\r\n", charGetName(ch));
-      roomSetDesc(new_room, desc);
-
-      zoneAddRoom(zone, new_room);
-      roomDigExit(charGetRoom(ch), dir, vnum);
-      roomDigExit(new_room, dirGetOpposite(dir), 
-		  roomGetVnum(charGetRoom(ch)));
-
-      worldSaveRoom(gameworld, new_room);
-      worldSaveRoom(gameworld, charGetRoom(ch));
-
-      try_move(ch, dir, NULL);
-      return TRUE;
-    }
-  }
-  return FALSE;
-}
+    ROOM_DATA  *old_room = charGetRoom(ch);
 
+    // try all of our exit hooks
+    hookRun("exit", ch, old_room, exit);
 
-bool try_move(CHAR_DATA *ch, int dir, const char *specdir) {
-  EXIT_DATA *exit = NULL;
-  if(dir != DIR_NONE)      
-    exit = roomGetExit(charGetRoom(ch), dir);
-  else if(specdir != NULL) 
-    exit = roomGetExitSpecial(charGetRoom(ch), specdir);
+    char_from_room(ch);
+    char_to_room(ch, to);
+    look_at_room(ch, charGetRoom(ch));
 
-  if(exit == NULL || !can_see_exit(ch, exit)) {
-    // see if we can buildwalk a new room
-    if(bitIsOneSet(charGetPrfs(ch), "buildwalk"))
-      return try_buildwalk(ch, dir);
-    else
-      send_to_char(ch, "{gAlas, there is no exit in that direction.\r\n");
-    return FALSE;
-  }
+    // now try all of our entrance hooks
+    hookRun("enter", ch, to, NULL);
 
-  else {
-    ROOM_DATA *old_room = charGetRoom(ch);
-    ROOM_DATA *new_room = try_exit(ch, exit, dir);
-    if(new_room) {
-      // move ourself back for a second so we can do the exit script...
-      char_to_room(ch, old_room);
-      try_exit_script(ch, old_room, 
-		      (dir != DIR_NONE ? dirGetName(dir) : specdir));
-      char_to_room(ch, new_room);
-
-      try_enterance_script(ch, charGetRoom(ch),
-			   (dir != DIR_NONE ? dirGetName(dir) : specdir));
-      look_at_room(ch, new_room);
-    }
-    return (new_room != NULL);
+    return exit;
   }
-}
 
+  // our exit failed
+  return NULL;
+}
 
 //
 // cmd_move is the basic entry into all of the movement utilities. See
 // try_move() in movement.h
-//
 COMMAND(cmd_move) {
-  if(subcmd == DIR_NONE) {
-    send_to_char(ch, "In which direction did you wish to move?\r\n");
-    return;
-  };
-
-  try_move(ch, subcmd, NULL);
+  try_move_mssg(ch, cmd);
 }
 
 
 
 //*****************************************************************************
-//
 // Functions and commands for changing position (sleeping, standing, etc)
-//
 //*****************************************************************************
 bool try_change_pos(CHAR_DATA *ch, int pos) {
   if(charGetPos(ch) == pos) {
diff -ruN ../nakedmudv2.7/src/movement.h src/movement.h
--- ../nakedmudv2.7/src/movement.h	Sun Jul 31 17:13:53 2005
+++ src/movement.h	Fri Oct  7 14:15:55 2005
@@ -1,5 +1,5 @@
-#ifndef __MOVEMENT_H
-#define __MOVEMENT_H
+#ifndef MOVEMENT_H
+#define MOVEMENT_H
 //*****************************************************************************
 //
 // movement.h
@@ -8,30 +8,20 @@
 //
 //*****************************************************************************
 
-
-
-//
-// Try to move in a specified direction. Returns true if the move was
-// successful, and false otherwise. A move might be false if a) there is
-// no (noticable) opened exit in the direction, the character is busy with
-// some activity (e.g. fighting) that will not let him move, or his position
-// is not one that is easily movable in (e.g. sleeping, resting, dead).
-// if dir != DIR_NONE, then it is tried. Otherwise, specdir is tried
-// as a room-specific direction to exit in.
-//
-bool try_move(CHAR_DATA *ch, int dir, const char *specdir);
-
-//
-// Go through an exit. use dir for display purposes to the room
-// (e.g. bob leaves north). If dir == DIR_NONE, no direction info
-// is said. Return the new room we are in, if we moved
-//
-ROOM_DATA *try_exit(CHAR_DATA *ch, EXIT_DATA *exit, int dir);
-
-//
-// Try creating a new room in the specified direction, drawn from the
-// zone we're currently in.
 //
-bool try_buildwalk(CHAR_DATA *ch, int dir);
+// Try to move in a specified direction. Returns the exit that was gone through
+// if successful. A move might be false if a) there is a no (noticable) opened
+// exit in the direction, the character is busy with some activity
+// (.e.g fighting) that will not let him move, or his position is not one that
+// is easily movable in (e.g. sleeping, resting, dead). The direction can be
+// anything. Abbreviations of the normal directions (n, s, e, w) are handled
+// properly by this function. Does not send messages to the rooms saying the
+// person has entered/exited.
+EXIT_DATA *try_move(CHAR_DATA *ch, const char *dir);
+
+//
+// Exactly the same as try_move, except this also sends messages saying the
+// person has entered/exited.
+EXIT_DATA *try_move_mssg(CHAR_DATA *ch, const char *dir);
 
-#endif // __MOVEMENT_H
+#endif // MOVEMENT_H
diff -ruN ../nakedmudv2.7/src/mud.c src/mud.c
--- ../nakedmudv2.7/src/mud.c	Sun Jul 31 17:13:53 2005
+++ src/mud.c	Fri Oct  7 14:15:55 2005
@@ -31,6 +31,12 @@
 //*****************************************************************************
 void init_mud_settings() {
   settings = storage_read(MUD_DATA);
+
+  // make sure we have initial values for some stuff
+  if(!*mudsettingGetString("start_room"))
+    mudsettingSetString("start_room", DFLT_START_ROOM);
+  if(mudsettingGetInt("pulses_per_second") == 0)
+    mudsettingSetInt("pulses_per_second", DFLT_PULSES_PER_SECOND);
 }
 
 void mudsettingSetString(const char *key, const char *val) {
